/* unit ppinkchiprst;
// blk   1
// lcyan 2
// cyan  3
// lmag  4
// lblk  6 */
#include <windows.h>
#include "DLPORTIO.h"
#include <stdio.h>     /* for printf */
#include <stdlib.h>    /* for exit */
#include <getopt.h>	/*Command line option */
#include <unistd.h>
/*#include <sys/io.h>*/
#include <sys/time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <time.h>
#include <string.h>
#define LPT 0x378       /*Port Addres(0x378,0x3BC,0x278)*/
#define PORT_OUT LPT+0  /*OUTPUT: Data port*/
#define PORT_IN LPT+1   /*INPUT: Status port, which is not used here*/
#define CNTL LPT+2      /*OUTPUT: Control port for Enabel,RegisterSelect,Backlit*/
 
void showinput();
void powerup();
void powerdown();
void syncup();
void syncdown();
void repeatgetchip();
void dataup();
void datadown();
void ReadChip();
void resetinklevel();
void savedata(char* fname);
void readfile();
void showdata(int *data_dump);
void zerofirst();
void resetport();
void Makeempty();
void blindreset();
void writechip( int, unsigned char *);
static void usage(void);
void readchip3Click();
void resetblack();
void resetcolor();
void sendbyte(int byt);

int chipid,portdata,mscount,chiparray[1000];
int syncmask 	= 0x01;
int clockmask 	= 0x02;
int datamask 	= 0x04;
int rwmask 	= 0x08;
int powermask 	= 0xE0;
int inmask 	= 0x10;
time_t c_time;

unsigned char inb(unsigned int PAddr)
{
  inportb(PAddr);
}
void outb(unsigned char Data,unsigned short  PAddr)
{
  outportb(PAddr, Data);
}
void delay10Ms(){
	usleep(10000UL);
}
void delay1ms(){
	usleep(1000UL);
}
void delay500us(){
       usleep(50UL);
}

void delay5us(){
      usleep(5UL);
}

void wrisread(){
	portdata = portdata & (rwmask ^ 0xff);
	outb(portdata,PORT_OUT);
}

void wriswrite(){
        portdata=portdata | rwmask;
        outb(portdata,PORT_OUT);
}

void powerup(){
        portdata=portdata | powermask;
        outb(portdata,PORT_OUT);
}

void powerdown(){
        portdata=portdata & (powermask ^ 0xff);
        outb(portdata,PORT_OUT);
}

void clockup(){
        portdata=portdata | clockmask;
        outb(portdata,PORT_OUT);
}

void clockdown(){
        portdata=portdata & (clockmask ^ 0xff);
        outb(portdata,PORT_OUT);
}

void syncup(){
        portdata=portdata | syncmask;
        outb(portdata,PORT_OUT);
}

void syncdown(){
        portdata=portdata & (syncmask ^ 0xff);
        outb(portdata,PORT_OUT);
}

void datadown(){
        portdata=portdata & (datamask ^ 0xff);
        outb(portdata,PORT_OUT);
}

void dataup(){
        portdata=portdata | datamask;
        outb(portdata,PORT_OUT);
}

void org_sendnibble(int nib){
    int i;
    for (i=1;i<=4;i++){
        if ((nib & 1) != 0) dataup();
	else 	datadown();
        clockup();
        delay5us();
        clockdown();
        delay5us();
        nib=nib >> 1;
    }
}
void sendnibble(int nib){
    int i;
    for (i=1;i<=4;i++){
        if ((nib & 1) != 0) dataup();
	else 	datadown();
        clockup();
        delay1ms();
        clockdown();
        delay1ms();
        nib=nib >> 1;
    }
}
void org_sendbyte(int byt){
    int i;
    for (i=1;i<=8;i++){
        if ((byt & 1) != 0)  dataup();
       	else datadown();
        clockup();
        delay500us();
        clockdown();
        delay500us();
        byt=byt >> 1;
    }
}
void sendbyte(int byt){
    int i;
    for (i=1;i<=8;i++){
        if ((byt & 1) != 0)  dataup();
       	else datadown();
        clockup();
        delay1ms();
        //delay500us();
        clockdown();
        delay1ms();
       // delay500us();
        byt=byt >> 1;
    }
}


void resetport(){
	outb(0,PORT_OUT);
}

